const fetch = require('node-fetch');
const watiEndpoint = process.env.WATI_ENDPOINT;
const watiBearerToken = process.env.WATI_BEARER_TOKEN;

module.exports = class WatiService {

  templates = {
    userCreated: "user_created",
    userCreatedAdmin: "user_created_admin",
    pujariAssigned: "puja_assigned_pujari_notification",
    pujariCreated: "pujari_creation_pujari_notification",
    pujaCreatedUser: "puja_created_user",
    sharePDF: "booking_template_pdf"
  }
  adminPhone = "919381062567"

  static async sendWhatsappMessage(mobileNumber, templateName, parameters) {

    console.log('mobile number , pdf', mobileNumber);

    const url = `${watiEndpoint}/api/v1/sendTemplateMessage/?whatsappNumber=${mobileNumber}`;
    console.log('URL WAS ', url);

    const options = {
      method: 'POST',
      headers: {
        'content-type': 'text/json',
        Authorization: watiBearerToken
      },
      body: JSON.stringify({
        "template_name": templateName,
        "broadcast_name": "broad cast message title",
        "parameters": parameters || []
      })
    };
    console.log('SENDING OPTIONS', options);

    try {
      const fetchResponse = await fetch(url, options);
      console.log('FETCH RESPONSE ', fetchResponse);

      const fetchResponseInJson = await fetchResponse.json();
      console.log('FETCH RESPONSE IN JSON ', fetchResponseInJson);
      return fetchResponseInJson;
    } catch (err) {
      return err;
    }

  }
}
