import { Controller, Get, Logger } from '@nestjs/common';
import { ApiOperation } from '@nestjs/swagger';
import { AppService } from './app.service';
import { APIFailedException } from './common/exceptions';

@Controller()
export class AppController {
  logger: Logger;

  constructor(private readonly appService: AppService) {
    this.logger = new Logger();
  }

  @Get()
  @ApiOperation({ summary: 'Welcome API Please ignore this' })
  async getHello(): Promise<string | null> {
    try {
      this.logger.debug('API Triggered');

      return this.appService.getHello();
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
    } catch (error: any) {
      this.logger.error(error);
      throw new APIFailedException(error);
    }
  }
}
