/* eslint-disable @typescript-eslint/no-explicit-any */
export enum EVENT_TYPE {
  REMOTE = 'remote',
  AT_MY_HOME = 'at_my_home',
  NEAR_MY_HOME = 'near_my_home',
  ON_BEHALF = 'on_behalf',
}

export enum BOOKING_STATUS {
  SUBMITTED = 'submitted',
  PUJARI_ASSIGNED = 'pujari_assigned',
  PLAN_UNDER_REVIEW = 'plan_under_review',
  PLAN_APPROVED = 'plan_approved',
  PUJARI_ACCEPTED = 'pujari_accepted',
  PUJARI_REJECTED = 'pujari_rejected',
  PUJA_STARTED = 'puja_started',
  PUJA_ENDED = 'puja_ended',
  PUJARI_AMOUNT_CREDITED = 'pujari_amount_credited',
}

export enum STATE {
  ACTIVE = 'active',
  SUSPENDED = 'suspended',
  COMPLETED = 'completed',
  CANCELLED = 'cancelled',
}

export enum SAMAGRI_STATUS {
  NONE = 'none',
  SAMAGRI_UNDER_REVIEW = 'samagri_under_review',
  PROCURED = 'procured',
  PACKED = 'packed',
  ON_THE_WAY = 'on_the_way',
  DELIVERED = 'delivered',
}

export enum PAYMENT_STATUS {
  PENDING = 'pending',
  PARTIAL = 'partial',
  COMPLETED = 'completed',
  REFUNDED = 'refunded',
}

export enum UpdateBookingStatus {
  PUJA_STARTED = 'puja_started',
  PUJA_ENDED = 'puja_ended',
}

export enum SamagriType {
  Default = 'default',
  Addon = 'addon',
}

export enum IsProvidedBy {
  Karishye = 'karishye',
  User = 'user',
  Pujari = 'pujari',
}

const fontSize10 = 10;
const borderColor = ['#C7B062', '#C7B062', '#C7B062', '#C7B062'];
const cellheight = [0, 4, 0, 4];
const centerAlign = 'center';
export const samagriTable: any = [
  [
    {
      text: 'Item Description',
      fontSize10,
      fillColor: '#C7B062',
      borderColor: borderColor,
      margin: cellheight,
      alignment: centerAlign,
    },
    {
      text: 'Qty',
      fontSize10,
      fillColor: '#C7B062',
      borderColor: borderColor,
      margin: cellheight,
      alignment: centerAlign,
    },
    {
      text: 'Rate',
      fontSize10,
      fillColor: '#C7B062',
      borderColor: borderColor,
      margin: cellheight,
      alignment: centerAlign,
    },
  ],
];
