import { Module } from '@nestjs/common';
import { ConfigModule as NestConfigModule } from '@nestjs/config';
import { ConfigService } from './config.service';
import { join } from 'path';

@Module({
  imports: [
    NestConfigModule.forRoot({
      isGlobal: true,
      envFilePath: join(__dirname, '../../environments', `.env.${process.env.NODE_ENV || 'local'}`)
    })
  ],
  providers: [ConfigService],
  exports: [ConfigService]
})
export class ConfigModule {} 