"use strict";

module.exports = function (sequelize, DataTypes) {
  const booking_participants = sequelize.define(
    "booking_participants",
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },
      booking_id: {
        type: DataTypes.UUID,
        references: {
          model: "bookings",
          key: "id",
        },
      },
      member_id: {
        type: DataTypes.UUID,
        allowNull: true,
      },
      user_id: {
        type: DataTypes.UUID,
        allowNull: true,
      },
      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
      createdById: {
        type: DataTypes.UUID,
        allowNull: true,
      },
      updatedById: {
        type: DataTypes.UUID,
        allowNull: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
    }
  );

  booking_participants.associate = (models) => {
    booking_participants.belongsTo(models.bookings, {
      foreignKey: "booking_id",
      as: "booking",
    });
  };

  return booking_participants;
};
