module.exports = function (sequelize, DataTypes) {
  const puja_model_samagri_mappings = sequelize.define(
    'puja_model_samagri_mappings',
    {
      id: {
        type: DataTypes.INTEGER,
        primaryKey: true,
        autoIncrement: true,
      },

      model_id: {
        type: DataTypes.INTEGER,
      },

      samagri_id: {
        type: DataTypes.INTEGER,
      },

      no_of_standard_qty: {
        type: DataTypes.INTEGER,
      },

      createdAt: {
        type: DataTypes.DATE,
      },

      createdById: {
        type: DataTypes.UUID,
      },

      deletedAt: {
        type: DataTypes.DATE,
      },

      updatedAt: {
        type: DataTypes.DATE,
      },

      updatedById: {
        type: DataTypes.UUID,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },

      isProvidedBy: {
        type: DataTypes.ENUM,
        values: ['karishye', 'user', 'pujari'],
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  return puja_model_samagri_mappings;
};
