
module.exports = function (sequelize, DataTypes) {
  const puja_samagri_mappings = sequelize.define(
    'puja_samagri_mappings',
    {
      id: {
        type: DataTypes.UUID,
        primaryKey: true,
      },

      puja_id: {
        type: DataTypes.INTEGER,
      },

      samagri_id: {
        type: DataTypes.UUID,
      },

      no_of_standard_qty: {
        type: DataTypes.INTEGER,
      },

      isProvidedBy: {
        type: DataTypes.ENUM,
        values: ['karishye', 'user', 'pujari'],
      },
      samagri_type: {
        type: DataTypes.ENUM,
        values: ['default', 'addon'],
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  puja_samagri_mappings.associate = (db) => {
    db.puja_samagri_mappings.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.puja_samagri_mappings.belongsTo(db.users, {
      as: 'updatedBy',
    });

    db.puja_samagri_mappings.belongsTo(db.pujas, {
      foreignKey: 'puja_id',
    });

    db.puja_samagri_mappings.belongsTo(db.samagri, {
      foreignKey: 'samagri_id',
    });
  };

  return puja_samagri_mappings;
};
