import { Column, Entity, JoinColumn, ManyToOne, PrimaryColumn } from 'typeorm';
import { Bookings } from './bookings';
import { KarishyeUsers } from './karishye-users';

@Entity('booking_participants')
export class BookingParticipants {
  @PrimaryColumn({ name: 'id', type: 'int' })
  readonly id: number;

  @Column({ name: 'booking_id', type: 'int' })
  readonly bookingId?: number;

  @Column({ name: 'member_id', type: 'int' })
  readonly memberId?: number;

  @Column({ name: 'user_id', type: 'int' })
  readonly userId?: number;

  @Column({ name: 'updatedAt', type: 'timestamp' })
  readonly updatedAt?: Date;

  @Column({ name: 'deletedAt', type: 'timestamp' })
  readonly deletedAt?: Date;

  @Column({ name: 'createdAt', type: 'timestamp' })
  readonly createdAt?: Date;

  @Column({ name: 'importHash', type: 'varchar' })
  readonly importHash?: string;

  @Column({ name: 'createdById', type: 'char' })
  readonly createdById?: string;

  @Column({ name: 'updatedById', type: 'char' })
  readonly updatedById?: string;

  @ManyToOne(() => KarishyeUsers, (user) => user.participant)
  @JoinColumn({ name: 'member_id' })
  readonly memberid!: KarishyeUsers;

  @ManyToOne(() => KarishyeUsers, (user) => user.participants)
  @JoinColumn({ name: 'user_id' })
  readonly userid!: KarishyeUsers;

  @ManyToOne(() => Bookings, (booking) => booking.bookingparticipants)
  @JoinColumn({ name: 'booking_id' })
  readonly booking!: Bookings;

  constructor(
    id: number,
    bookingId?: number,
    memberId?: number,
    userId?: number,
    updatedAt?: Date,
    createdAt?: Date,
    deletedAt?: Date,
    importHash?: string,
    createdById?: string,
    updatedById?: string
  ) {
    this.id = id;
    this.bookingId = bookingId;
    this.memberId = memberId;
    this.userId = userId;
    this.updatedAt = updatedAt;
    this.deletedAt = deletedAt;
    this.importHash = importHash;
    this.createdAt = createdAt;
    this.createdById = createdById;
    this.updatedById = updatedById;
  }
}
