import {
  Column,
  Entity,
  JoinColumn,
  ManyToOne,
  PrimaryGeneratedColumn,
} from 'typeorm';
import { Bookings } from './bookings';
import { PujaProcedures } from './puja-procedures';

@Entity('booking_procedure_mappings')
export class BookingProcedureMappings {
  @PrimaryGeneratedColumn({ name: 'id', type: 'int' })
  readonly id: number;

  @Column({ name: 'booking_id', type: 'int' })
  readonly bookingId?: number;

  @Column({ name: 'procedure_id', type: 'int' })
  readonly procedureId?: number;

  @Column({ name: 'order', type: 'int' })
  readonly order?: number;

  @ManyToOne(
    () => PujaProcedures,
    (procedures) => procedures.bookingproceduremapping
  )
  @JoinColumn({ name: 'procedure_id' })
  readonly procedure!: PujaProcedures;

  @ManyToOne(() => Bookings, (booking) => booking.bookingproceduremappings)
  @JoinColumn({ name: 'booking_id' })
  readonly bookings!: Bookings;

  constructor(
    id: number,
    bookingId?: number,
    procedureId?: number,
    order?: number
  ) {
    this.id = id;
    this.bookingId = bookingId;
    this.procedureId = procedureId;
    this.order = order;
  }
}
