import { Column, Entity, JoinColumn, ManyToOne, PrimaryColumn } from 'typeorm';
import { Categories } from './categories';
import { Pujas } from './pujas';
import { SubCategories } from './sub-categories';

@Entity('puja_category_mappings')
export class PujaCategoryMappings {
  @PrimaryColumn({ name: 'id', type: 'int' })
  readonly id: number;

  @Column({ name: 'puja_id', type: 'int' })
  readonly pujaId?: number;

  @Column({ name: 'category_id', type: 'int' })
  readonly categoryId?: number;

  @Column({ name: 'sub_category_id', type: 'int' })
  readonly subCategoryId?: number;

  @ManyToOne(() => Pujas, (model) => model.pujacategorymappings)
  @JoinColumn({ name: 'puja_id' })
  readonly pujas!: Pujas;

  @ManyToOne(
    () => Categories,
    (categorymapping) => categorymapping.pujacategorymappings
  )
  @JoinColumn({ name: 'category_id' })
  readonly categories!: Categories;

  @ManyToOne(
    () => SubCategories,
    (subcategorymapping) => subcategorymapping.pujasubcategorymappings
  )
  @JoinColumn({ name: 'sub_category_id' })
  readonly subCategories!: SubCategories;

  constructor(id: number, pujaId?: number, categoryId?: number) {
    this.id = id;
    this.pujaId = pujaId;
    this.categoryId = categoryId;
  }
}
