import {
  Column,
  Entity,
  JoinColumn, ManyToOne,
  OneToOne,
  PrimaryColumn
} from 'typeorm';
import { PujaModels } from './puja-models';
import { PujaProcedures } from './puja-procedures';

@Entity('puja_model_procedure_mappings')
export class PujaModelProcedureMappings {
  @PrimaryColumn({ name: 'id', type: 'int' })
  readonly id: number;

  @Column({ name: 'model_id', type: 'int' })
  readonly modelId?: number;

  @Column({ name: 'procedure_id', type: 'int' })
  readonly procedureId?: number;

  @ManyToOne(() => PujaModels, (modelmapping) => modelmapping.procedures)
  @JoinColumn({ name: 'model_id' })
  readonly pujamodels!: PujaModels;

  @OneToOne(() => PujaProcedures)
  @JoinColumn({ name: 'procedure_id', referencedColumnName: 'id' })
  readonly procedure!: PujaProcedures;

  constructor(id: number, modelId?: number, procedureId?: number) {
    (this.id = id), (this.modelId = modelId), (this.procedureId = procedureId);
  }
}
