import {
  Column,
  Entity,
  JoinColumn,
  ManyToOne,
  OneToOne,
  PrimaryColumn,
} from 'typeorm';
import { PujaModels } from './puja-models';
import { Samagri } from './samagri';

@Entity('puja_model_samagri_mappings')
export class PujaModelSamagriMappings {
  @PrimaryColumn({ name: 'id', type: 'int' })
  readonly id: number;

  @Column({ name: 'model_id', type: 'int' })
  readonly modelId?: number;

  @Column({ name: 'samagri_id', type: 'int' })
  readonly samagriId?: number;

  @Column({ name: 'no_of_standard_qty', type: 'int' })
  readonly qty?: number;

  @Column({ name: 'updatedAt', type: 'timestamp' })
  readonly updatedAt?: Date;

  @Column({ name: 'deletedAt', type: 'timestamp' })
  readonly deletedAt?: Date;

  @Column({ name: 'createdAt', type: 'timestamp' })
  readonly createdAt?: Date;

  @Column({ name: 'importHash', type: 'varchar' })
  readonly importHash?: string;

  @Column({ name: 'createdById', type: 'char' })
  readonly createdById?: string;

  @Column({ name: 'updatedById', type: 'char' })
  readonly updatedById?: string;

  @ManyToOne(() => PujaModels, (model) => model.samagris)
  @JoinColumn({ name: 'model_id' })
  readonly model!: PujaModels;

  @OneToOne(() => Samagri)
  @JoinColumn({ name: 'samagri_id', referencedColumnName: 'id' })
  readonly samagri!: Samagri;

  constructor(
    id: number,
    modelId?: number,
    samagriId?: number,
    qty?: number,
    updatedAt?: Date,
    createdAt?: Date,
    deletedAt?: Date,
    importHash?: string,
    createdById?: string,
    updatedById?: string
  ) {
    this.id = id;
    this.modelId = modelId;
    this.samagriId = samagriId;
    this.qty = qty;
    this.updatedAt = updatedAt;
    this.deletedAt = deletedAt;
    this.importHash = importHash;
    this.createdAt = createdAt;
    this.createdById = createdById;
    this.updatedById = updatedById;
  }
}
