import { Column, Entity, JoinColumn, ManyToOne, PrimaryColumn } from 'typeorm';
import { Pujas } from './pujas';
import { Samagri } from './samagri';

@Entity('puja_samagri_mappings')
export class PujaSamagriMappings {
  @PrimaryColumn({ name: 'id', type: 'varchar' })
  readonly id: string;

  @Column({ name: 'no_of_standard_qty', type: 'int' })
  readonly noOfStandardQty?: number;

  @Column({ name: 'puja_id', type: 'int' })
  readonly pujaId?: number;

  @Column({ name: 'samagri_id', type: 'int' })
  readonly samagriId?: number;

  @Column({ name: 'isProvidedBy', type: 'char' })
  readonly isProvidedBy?: string;

  @Column({ name: 'samagri_type', type: 'char' })
  readonly samagriType?: string;

  @ManyToOne(() => Pujas, (puja) => puja.pujaSamagriMappings)
  @JoinColumn({ name: 'puja_id' })
  readonly puja!: Pujas;

  @ManyToOne(() => Samagri, (samagri) => samagri.pujaSamagriMappings)
  @JoinColumn({ name: 'samagri_id' })
  readonly samagri!: Samagri;

  constructor(
    id: string,
    noOfStandardQty?: number,
    pujaId?: number,
    samagriId?: number,
    isProvidedBy?: string,
    samagriType?: string
  ) {
    this.id = id;
    this.isProvidedBy = isProvidedBy;
    this.noOfStandardQty = noOfStandardQty;
    this.pujaId = pujaId;
    this.pujaId = pujaId;
    this.samagriType = samagriType;
  }
}
