import { Column, Entity, OneToOne, PrimaryColumn } from 'typeorm';
import { Pujaris } from './pujaris';
@Entity('pujari_applications')
export class PujariApplications {
  @PrimaryColumn({ name: 'id' })
  readonly id: number;

  @Column({ name: 'name' })
  readonly name?: string;

  @Column({ name: 'surname' })
  readonly surname?: string;

  @Column({ name: 'date_of_birth' })
  readonly dateOfBirth?: Date;

  @Column({ name: 'qualification' })
  readonly qualification?: string;

  @Column({ name: 'experience_yrs' })
  readonly experienceYrs?: number;

  @Column({ name: 'address' })
  readonly address?: string;

  @Column({ name: 'email_id' })
  readonly emailId?: string;

  @Column({ name: 'phone_number' })
  readonly phoneNumber?: string;

  @Column({ name: 'photo' })
  readonly photo?: string;

  @Column({ name: 'video' })
  readonly video?: string;

  @Column({ name: 'gender' })
  readonly gender?: string;

  @Column({ name: 'application_status' })
  readonly applicationStatus?: string;

  @Column({ name: 'language' })
  readonly language?: string;

  @Column({ name: 'online_pujas' })
  readonly onlinePujas?: boolean;

  @Column({ name: 'travel' })
  readonly travel?: boolean;

  @Column({ name: 'city' })
  readonly city?: string;

  @Column({ name: 'updatedAt', type: 'timestamp' })
  readonly updatedAt?: Date;

  @Column({ name: 'deletedAt', type: 'timestamp' })
  readonly deletedAt?: Date;

  @Column({ name: 'createdAt', type: 'timestamp' })
  readonly createdAt?: Date;

  @Column({ name: 'importHash', type: 'varchar' })
  readonly importHash?: string;

  @Column({ name: 'createdById', type: 'char' })
  readonly createdById?: string;

  @Column({ name: 'updatedById', type: 'char' })
  readonly updatedById?: string;

  @OneToOne(
    () => Pujaris,
    (pujarismapping) => pujarismapping.pujariapplications
  )
  readonly pujaris!: Pujaris;

  constructor(
    id: number,
    name?: string,
    surname?: string,
    dateOfBirth?: Date,
    qualification?: string,
    experienceYrs?: number,
    address?: string,
    emailId?: string,
    phoneNumber?: string,
    photo?: string,
    video?: string,
    gender?: string,
    applicationStatus?: string,
    language?: string,
    onlinePujas?: boolean,
    travel?: boolean,
    city?: string,
    updatedAt?: Date,
    createdAt?: Date,
    deletedAt?: Date,
    importHash?: string,
    createdById?: string,
    updatedById?: string
  ) {
    this.id = id;
    this.name = name;
    this.surname = surname;
    this.dateOfBirth = dateOfBirth;
    this.qualification = qualification;
    this.experienceYrs = experienceYrs;
    this.address = address;
    this.emailId = emailId;
    this.phoneNumber = phoneNumber;
    this.photo = photo;
    this.video = video;
    this.gender = gender;
    this.applicationStatus = applicationStatus;
    this.language = language;
    this.onlinePujas = onlinePujas;
    this.travel = travel;
    this.city = city;
    this.updatedAt = updatedAt;
    this.deletedAt = deletedAt;
    this.importHash = importHash;
    this.createdAt = createdAt;
    this.createdById = createdById;
    this.updatedById = updatedById;
  }
}
