import { Column, Entity, JoinColumn, OneToMany, PrimaryColumn } from 'typeorm';
import { PujaCategoryMappings } from './puja-category-mappings';
import { PujaModels } from './puja-models';
import { PujaHistory } from './puja_history';
import { PujaSamagriMappings } from './puja-samagri-mappings';
@Entity('pujas')
export class Pujas {
  @PrimaryColumn({ name: 'id' })
  readonly id?: number;

  @Column({ name: 'name' })
  readonly name?: string;

  @Column({ name: 'url_name' })
  readonly url_name?: string;

  @Column({ name: 'description' })
  readonly description?: string;

  @Column({ name: 'language' })
  readonly language?: string;

  @Column({ name: 'region' })
  readonly region?: string;

  @Column({ name: 'mode1' })
  readonly mode1?: string;

  @Column({ name: 'mode2' })
  readonly mode2?: string;

  @Column({ name: 'mode3' })
  readonly mode3?: string;

  @Column({ name: 'mode4' })
  readonly mode4?: string;

  @Column({ name: 'videos' })
  readonly videos?: string;

  @Column({ name: 'images' })
  readonly images?: string;

  @Column({ name: 'updatedAt', type: 'timestamp' })
  readonly updatedAt?: Date;

  @Column({ name: 'deletedAt', type: 'timestamp' })
  readonly deletedAt?: Date;

  @Column({ name: 'createdAt', type: 'timestamp' })
  readonly createdAt?: Date;

  @Column({ name: 'importHash', type: 'varchar' })
  readonly importHash?: string;

  @Column({ name: 'createdById', type: 'char' })
  readonly createdById?: string;

  @Column({ name: 'updatedById', type: 'char' })
  readonly updatedById?: string;

  @OneToMany(() => PujaCategoryMappings, (model) => model.pujas)
  @JoinColumn({ name: 'id' })
  readonly pujacategorymappings!: PujaCategoryMappings;

  @OneToMany(() => PujaModels, (model) => model.puja)
  @JoinColumn({ name: 'id' })
  readonly pujamodels!: PujaModels;

  @OneToMany(() => PujaHistory, (model) => model.puja)
  @JoinColumn({ name: 'id' })
  readonly pujaHistory!: PujaHistory;

  @OneToMany(() => PujaSamagriMappings, (model) => model.puja)
  @JoinColumn({ name: 'id' })
  readonly pujaSamagriMappings!: PujaSamagriMappings;

  constructor(
    id?: number,
    name?: string,
    url_name?: string,
    description?: string,
    language?: string,
    region?: string,
    mode1?: string,
    mode2?: string,
    mode3?: string,
    mode4?: string,
    videos?: string,
    images?: string,
    updatedAt?: Date,
    createdAt?: Date,
    deletedAt?: Date,
    importHash?: string,
    createdById?: string,
    updatedById?: string
  ) {
    this.id = id;
    this.name = name;
    this.url_name = url_name;
    this.description = description;
    this.language = language;
    this.region = region;
    this.mode1 = mode1;
    this.mode2 = mode2;
    this.mode3 = mode3;
    this.mode4 = mode4;
    this.videos = videos;
    this.images = images;
    this.updatedAt = updatedAt;
    this.deletedAt = deletedAt;
    this.importHash = importHash;
    this.createdAt = createdAt;
    this.createdById = createdById;
    this.updatedById = updatedById;
  }
}
