import { Controller, Get, Query } from '@nestjs/common';
import { ApiOperation } from '@nestjs/swagger';
import { UserPayload } from '../pujari/users/models/twilio.dto';
import { LoginService } from './login.service';
//import { AuthService } from 'src/auth/auth.service';
@Controller('login')
export class LoginController {
  constructor(private loginService: LoginService) {}

  @Get('user-login')
  @ApiOperation({ summary: 'user login' })
  async userLogin(
    @Query() data: UserPayload
  ): Promise<{ status: string } | null> {
    return await this.loginService.userLogin(data);
  }

  @Get('user-signup')
  @ApiOperation({ summary: 'user signup message' })
  async userSignup(
    @Query() data: UserPayload
  ): Promise<{ status: string } | null> {
    return await this.loginService.userSignUp(data);
  }

  @Get('validate-otp')
  @ApiOperation({ summary: 'user login otp validation' })
  async validateOTP(
    @Query() data: UserPayload
  ): Promise<{ status: string } | null> {
    return await this.loginService.validateOTP(data);
  }
}
