import { ApiProperty, ApiPropertyOptional } from '@nestjs/swagger';
import { IsNotEmpty, IsNumber, IsOptional, IsString } from 'class-validator';

export class PujaProcedureDto {
  @ApiProperty()
  @IsNumber()
  @IsNotEmpty()
  public id: number;

  @ApiPropertyOptional()
  @IsNumber()
  @IsOptional()
  public language: string;

  @ApiProperty()
  @IsNumber()
  public title: number;

  @ApiPropertyOptional()
  @IsString()
  @IsOptional()
  public description?: string;

  @ApiProperty()
  @IsString()
  public specialNotes: string;
}

export class PujaProceduresDto {
  @ApiProperty()
  @IsString()
  public status: string;

  @ApiProperty({
    type: PujaProcedureDto,
    isArray: true,
  })
  public data: PujaProcedureDto;
}
