import { HttpModule } from '@nestjs/axios';
import { MiddlewareConsumer, Module, NestModule } from '@nestjs/common';
import { LoggerMiddleware } from './../../middleware/logger';
import { PujaProcedureController } from './puja-procedure.controller';
import { PujaProcedureService } from './puja-procedure.service';

@Module({
  imports: [HttpModule],
  controllers: [PujaProcedureController],
  providers: [PujaProcedureService],
})
export class PujaProcedureModule implements NestModule {
  configure(consumer: MiddlewareConsumer) {
    consumer.apply(LoggerMiddleware).forRoutes('*');
  }
}
