import { Injectable, Logger } from '@nestjs/common';
import { AppDataSource } from 'src/common/db-utils';
import { APIFailedException } from 'src/common/exceptions';
import { PujaProcedures } from 'src/entities';

@Injectable()
export class PujaProcedureService {
  logger: Logger;

  constructor() {
    this.logger = new Logger();
  }

  async getAllPujaProcedures(): Promise<PujaProcedures[] | null> {
    try {
      const repo = AppDataSource.getRepository(PujaProcedures);
      this.logger.log('repo', repo);
      return await repo.find();
    } catch (error: any) {
      this.logger.error(error);
      throw new APIFailedException(error);
    }
  }
}
