import { ApiProperty } from '@nestjs/swagger';
import { IsOptional, IsString } from 'class-validator';

export class CreateUsersDto {
  @ApiProperty()
  @IsOptional()
  @IsString()
    id: string;

  @ApiProperty({ required: true, type: String })
  @IsString()
  public name: string;

  @ApiProperty({ required: true, type: String })
  @IsString()
  public surname: string;

  @ApiProperty({ type: String })
  @IsOptional()
  @IsString()
  public emailId: string;

  @ApiProperty({ type: String })
  @IsOptional()
  @IsString()
  public addressLine1: string;

  @ApiProperty({ type: String })
  @IsOptional()
  @IsString()
  public addressLine2: string;

  @ApiProperty({ type: String })
  @IsOptional()
  @IsString()
  public city: string;

  @ApiProperty({ type: String })
  @IsOptional()
  @IsString()
  public state: string;

  @ApiProperty({ type: String })
  @IsOptional()
  @IsString()
  public country: string;

  @ApiProperty({ type: String })
  @IsOptional()
  @IsString()
  public pincode: string;

  @ApiProperty({ required: true, type: String })
  @IsString()
  public phoneNumber: string;

  @ApiProperty({ type: String })
  @IsOptional()
  @IsString()
  public dateOfBirth: string;

  @ApiProperty({ type: String })
  @IsOptional()
  @IsString()
  public gothram: string;

  @ApiProperty({ type: String })
  @IsOptional()
  @IsString()
  public nakshatram: string;

  @ApiProperty({ type: String })
  @IsOptional()
  @IsString()
  public gender: string;

  @ApiProperty({ type: Boolean })
  @IsOptional()
  @IsString()
  public isNotify?: boolean;
}

export class UserDetailsQuery {
  @ApiProperty()
  @IsOptional()
  public id: string;
}
