import { ApiProperty, ApiPropertyOptional } from '@nestjs/swagger';
import { IsString } from 'class-validator';

export class TwilioPayload {
  @ApiProperty()
  @IsString()
    phoneNumber: string;

  @ApiPropertyOptional()
    otpCode: string;
}

export class UserPayload extends TwilioPayload {
  @ApiProperty({ required: true })
  @IsString()
    isPujari: string;
}

export class ContactPayload extends TwilioPayload {
  @ApiProperty()
  @IsString()
    firstName: string;

  @ApiProperty()
  @IsString()
    lastName: string;

  @ApiPropertyOptional()
    email: string;

  @ApiPropertyOptional()
    message: string;
}
