import { Injectable, Logger } from '@nestjs/common';
import { TwilioPayload } from '../../models/twilio.dto';
const accountSid =
  process.env.TWILIO_SID || 'AC9064fdd067466586f981ddfb5cf6ca99';
const authToken =
  process.env.TWILIO_AUTH_TOKEN || 'd90b5378b58883a03d4e05b7bbb97fad';

// eslint-disable-next-line @typescript-eslint/no-var-requires
const client = require('twilio')(accountSid, authToken);

@Injectable()
export class TwilioService {
  logger: Logger;
  verifySid: any;
  constructor() {
    // this.createTwilioService()
    // client.verify.v2.services
    //   .list()
    //   .then((services: any) =>
    //     services.forEach((s: any) => client.verify.v2.services(s.sid).remove())
    //   );
  }

  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  createTwilioService(phoneNumber: string) {
    // return client.verify.v2.services
    //   .create({ friendlyName: "Verify service" })

    return client.verify.v2
      .services('VA3f153a865a6303401baf3d2802f324ae')
      .fetch()
      .then((service: any) => {
        this.verifySid = service.sid;
        client.verify.v2.services(this.verifySid);
        // .rateLimits.create({
        //   description: "Limit on end user IP Address",
        //   uniqueName: phoneNumber.replace("+", ""),
        // })
        // .then((rate_limit: any) => this.logger.log(rate_limit.sid));

        return service.sid;
      })
      .catch((err: any) => {
        return { statusCode: 500, message: `${err}` };
      });
  }

  sendOTP(body: TwilioPayload) {
    return this.createTwilioService(body.phoneNumber)
      .then((res: any) => {
        return client.verify.v2
          .services(res)
          .verifications.create({ to: body.phoneNumber, channel: 'sms' })
          .then(() => {
            return {
              statusCode: 200,
              message: 'OTP Sent successfully',
              // data: verification,
            };
          })
          .catch((err: any) => {
            return { statusCode: 500, message: `${err}` };
          });
      })
      .catch((err: any) => {
        return { statusCode: 500, message: `${err}` };
      });
  }

  verifyOTP(body: TwilioPayload) {
    return this.createTwilioService(body.phoneNumber).then((res: any) => {
      return client.verify.v2
        .services(res)
        .verificationChecks.create({
          to: body.phoneNumber,
          code: body.otpCode,
        })
        .then((res: any) => {
          this.logger.log(res, 'res-->?');

          if (res.status === 'approved') {
            return {
              statusCode: 200,
              message: 'User verified successfully',
              // data: verification_check,
            };
          } else {
            return {
              statusCode: 500,
              message: 'User verified failed',
              // data: verification_check,
            };
          }
        })
        .catch((err: any) => {
          return { statusCode: 500, message: `${err}` };
        });
    });
  }
}
