import { HttpModule } from '@nestjs/axios';
import { MiddlewareConsumer, Module, NestModule } from '@nestjs/common';
import { LoggerMiddleware } from 'src/middleware/logger';
import { EmailService } from '../email-config/email.service';
import { WhatsappService } from '../whatsapp/whatsapp.service';
import { TwilioService } from './services/twilio/twilio.service';
import { UsersService } from './services/users/users.service';
import { UsersController } from './users.controller';
import { BookingsService } from '../bookings/bookings.service';

@Module({
  controllers: [UsersController],
  imports: [HttpModule],
  providers: [
    UsersService,
    TwilioService,
    WhatsappService,
    EmailService,
    BookingsService,
  ],
})
export class UsersModule implements NestModule {
  configure(consumer: MiddlewareConsumer) {
    consumer.apply(LoggerMiddleware).forRoutes('*');
  }
}
