import { HttpService } from '@nestjs/axios';
import { Injectable } from '@nestjs/common';
import { lastValueFrom, map } from 'rxjs';

@Injectable()
export class WhatsappService {
  constructor(private httpService: HttpService) { }

  sendWhatsappMessage = (
    phoneNumber: string,
    templateName: any,
    parameters: any
  ) => {
    try {
      const url = `${process.env.WATI_URL}/api/v1/sendTemplateMessage?whatsappNumber=${phoneNumber}`;
      const options = {
        headers: {
          'content-type': 'text/json',
          Authorization: `${process.env.WATI_API_KEY}`,
        },
        body: {
          broadcast_name: 'New-Booking',
          template_name: templateName,
          parameters: [...parameters],
        },
      };

      let result;

      lastValueFrom(
        this.httpService
          .post(url, options.body, { headers: options.headers })
          .pipe(map((res) => res.data))
      ).then((response) => (result = response));

      if (result) {
        return true;
      } else {
        return false;
      }
    } catch (error) {
      return error;
    }
  };
}
